<?php
/**
 * An exception thrown when required array elements are missing
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009, 2010 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
class MissingArrayElementsException extends FrameworkException {
	/**
	 * The constructor
	 *
	 * @param	$classArray		Array with exception data
	 * @param	$code			Code number for the exception
	 * @return	void
	 */
	public function __construct (array $classArray, $code) {
		// Extract all elements
		$elements = '';
		if ((isset($classArray[2])) && (is_array($classArray[2]))) {
			// Convert into strings
			$elements = implode('</u>, <u>', $classArray[2]);
		} else {
			// Invalid data
			$elements = 'invalid_data';
		}

		// Add a message around the missing class
		$message = sprintf("[%s:%d] Array <u>%s()</u> Does not have these elements: <span class=\"exception_reason\">%s</span>",
			$classArray[0]->__toString(),
			$this->getLine(),
			$classArray[1],
			$elements
		);

		// Call parent constructor
		parent::__construct($message, $code);
	}
}

// [EOF]
?>
