<?php
/**
 * This exception is thrown if the socket cannot be shut down is not error 107
 * which is "Transport endpoint not connected".
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009, 2010 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
class SocketShutdownException extends FrameworkException {
	/**
	 * A Constructor for this exception
	 *
	 * @param		$helperInstance		A BaseConnectionHelper instance
	 * @param		$code			Error code
	 * @return	void
	 */
	public function __construct (BaseConnectionHelper $helperInstance, $code) {
		// Get socket resource
		$socketResource = $helperInstance->getSocketResource();

		// Construct the message
		$message = sprintf("[%s:] Socket %s cannot be shutdown down. errNo=%s, errStr=%s",
			$helperInstance->__toString(),
			$socketResource,
			socket_last_error($socketResource),
			socket_strerror(socket_last_error($socketResource))
		);

		// Call parent exception constructor
		parent::__construct($message, $code);
	}
}

// [EOF]
?>
